// X^[g[_[ (for PC98) t@CovO

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

static unsigned char dir[0x800];
static unsigned char buffer[0x10000];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buffer, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buffer + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

int main(int argc, char *argv[])
{
	if (argc != 2)
	{
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();

	for (int d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x08);
		memset(dir, 0, sizeof(dir));
		int r = disk.ReadDATA(0, 0x00, 0x00, 0x02, 0x03, dir, sizeof(dir));

		int diskid = dir[0x200];
		if (r != sizeof(dir) || diskid > 1 || memcmp("KAIN",&dir[0x201],4))
		{
			fprintf(stderr, "fBXN %d ڂ͐fBXNł͂Ȃ悤ł.\n", d+1);
			continue;
		}

		printf("%d ߂̃C[Wt@C𒊏o܂.\n",d+1);

		// Program Diskp
		if (diskid==0x00)
		{
			fcut("BIOS", 0x00, 0x00, 0x00, 0x04, 0x03, 0x0000, 0x1c00);
		}
		for (int fnum = 0; fnum < 0x200/4; fnum++)
		{

			int trk = dir[fnum*4];
			int R = dir[fnum*4+1]+1;
			int size = (dir[fnum*4+3]<<8) + dir[fnum*4+2];
			if (size != 0)
			{
				char fname[32];
				char c = (diskid)? 'S' : 'P';
				sprintf(fname, "%c%02X", c, fnum);
				printf("%c%02X trk=%02x sec=%01x size=%04x\n", c, fnum, trk, R, size);
				int r = disk.ReadDATA(trk, trk/2, trk&1, R, 0x03, buffer, size);

				if (r != size)
				{
					fprintf(stderr, "*** ǂݍ݂Ɏs\n", fname);
					continue;
				}
				fp = fopen(fname, "wb");
				fwrite(buffer, 1, size, fp);
				fclose(fp);
			}
		}
	}

	return 0;
}
